stages:
  - build-1
  - build-2
  - publish

build-server:
  stage: build-1
  image: oracle/graalvm-ce:20.1.0-java11
  cache:
    paths:
      - $CI_PROJECT_DIR/server/target
      - $CI_PROJECT_DIR/server/server/target
      - $CI_PROJECT_DIR/server/shared/target
  before_script:
    - curl -Ls https://git.io/sbt > $CI_PROJECT_DIR/server/sbt
    - chmod 0755 $CI_PROJECT_DIR/server/sbt
  script:
    - cd server
    - ./sbt "project server" test assembly
  artifacts:
    paths:
      - $CI_PROJECT_DIR/server/server/target/scala-2.13/the-resistance-server-assembly-*.jar
    expire_in: 1 hour

build-client-lib:
  stage: build-1
  image: adoptopenjdk:11-openj9
  cache:
    paths:
      - $CI_PROJECT_DIR/server/target
      - $CI_PROJECT_DIR/server/client/target
  before_script:
    - curl -Ls https://git.io/sbt > $CI_PROJECT_DIR/server/sbt
    - chmod 0755 $CI_PROJECT_DIR/server/sbt
  script:
    - cd server
    - ./sbt "project client" fullOptJS
  artifacts:
    paths:
      - $CI_PROJECT_DIR/server/client/target/scala-2.13/the-resistance-client-opt.js
    expire_in: 1 hour

build-server-binary:
  stage: build-2
  image: oracle/graalvm-ce:20.1.0-java11
  before_script:
    - gu install native-image
  script:
    - cd server
    - ./build-native-image.sh
  artifacts:
    paths:
      - $CI_PROJECT_DIR/server/the-resistance-server-binary
    expire_in: 1 hour

build-client:
  stage: build-2
  image: node:12.18.2-alpine
  script:
    - cd client
    - npm install
    - npm run build
  artifacts:
    paths:
      - $CI_PROJECT_DIR/client/dist/bundle.js
    expire_in: 1 hour

publish-client:
  stage: publish
  only:
    - master
  image: node:12.18.2
  script:
    - (cd $CI_PROJECT_DIR/client && npm publish --access public)
